# Must be generated with
#   rat=(?[+-]?[0-9/]*)?
##################
# Step 0: local definition, loading
1i\
Zero:= affine(0,0) newline
/[ ]*load/d
/[ ]*set show/d
/[ ]*set print/d
##################
# Step 1: remove comments
/^[ ]*---/d
/\*\*\*(/,/\*\*\*)/d
/^[ ]*\*\*\*/d
s/\*\*\*.*$//
##################
# Step 2: Unitary tests
# search X =>* Y .  -> assert( X = Y )
#   2.1 :  mono-line unitary test
/search.*\.[ ]*$/{
  s/search/assert(/
  s/\.[ ]*$/) newline/
  s/=>\*/ = /g
}
#   2.2 :  multi-line unitary test
/search/,/\.[ ]*$/{  
  s/search/assert(/
  s/\.[ ]*$/) newline/
  s/=>\*/ = /g
}
##################
# Step 3: Modules
#   Keep only equation definition
/^[ ]*[f]*mod/,/^[ ]*end[f]*m/{
  s/[ ]*eq\([^=]*\)=\(.*\)\.[ ]*$/\1 := \2 newline/g
  t matched
  d
  :matched	
}
##################
# Step 4: Everywhere

  # remove useless parentheses
  s/ (\([0-9][0-9/]*\))/ \1/g
  # Operators
  s/ conv / * /g
  s/ conv$/ */g
  s: deconv : / :g
  s:h(:hDev(:
  s:subAddClos(:star(:g
  # Constructors
  s:Delta\ * \(${rat}\):delay(\1):g
  s:Lambda\ *\(${rat}\):affine(\1 , 0):g
  s:Gamma\ *\(${rat}\)\ *\(${rat}\):affine(\1 , \2):g
  s:Beta\ *\([0-9/]*\)\ *\([0-9/]*\):(affine(\1 , - \1 \* \2) \\/ Zero):g
  #  [ X ]+
  s:\[\([^]]*\)\][+]:( (\1) \\/ Zero ):g
  # [ X ] (eval)
  s:\[\([^]]*\)\]:(\1):
  # Specific operator
  s:NormalForm::g
  # CPL
  /cpl::/{
     s/cpl:://g
     s|:\([^=]\)|/\\\1|g
  }
  s/mkCpl//g

  # BetaTest
  s:\*[ ]*Test>:/\\ delay:g
  s:\*[ ]*(Test>:/\\ (delay:g

  	
##################
# Step 5: Specific to some files

# File testMinPlus-GammaMin.maude
s:mkGM::g
/test-cplSum/{
   s/test-cplSum//
   s/,/) + (/
   s|:|/\\|g
}

##################
# Step 6: Variable renaming
s/\([a-zA-Z]*\)'/\1p/g
s/\([a-zA-Z][a-zA-Z0-9]\)*\.\([a-zA-Z0-9]*\)/\1x\2/g



