# Run this script with
#  gnuplot -persist tests-NF-RedGreen.gnuplot
min(a,b) = a < b ? a : b 
min3(a,b,c) = min( a , min(b,c) )
min4(a,b,c,d) = min( min(a,b) , min(c,d) )
max(a,b) = a > b ? a : b 
Gamma(r,b,x) = x * r + b 

Red(x)   = min3( Gamma(5,0,x) , Gamma( 2./3. , 13, x ) , Gamma( 0 , 20 , x ) ) 
Green(x) = min3( Gamma(2,3,x) , Gamma(1 , 8 , x )      , Gamma( 1./3, 15,x)  ) 
MyRplusG(x) = min4( Gamma( 7 , 3 , x ) , Gamma( 8./3, 16, x ) , Gamma( 5./3, 21,x ) , Gamma( 1./3, 35, x ) )

set grid
set xtic 1
plot [0:20] Red(x), Green(x) , Red(x)+Green(x) , MyRplusG(x)

#plot [0:20] g1(x)+g2(x), b(x)
#g1p(x) = x / 3 + 5
#plot [0:20] g1p(x)+g2(x), b(x)
#set title "Grieu : switch I"
#plot [0:20] min( l(x) , g1(x) ) with p , min( l(x) , g2(x) ) with p , \
#	    min( l(x) , g1(x) ) + min( l(x) , g2(x) ), b(x) 
#set  title "Grieu : swith II"
#g1p(x) = min( x + 6 , x / 3 + 6 )
#plot [0:20] g1p(x), g1p(x) + min( l(x), g2(x) ), b(x)
